Index: LMDZ6/branches/Portage_acc/libf/phylmd/wake.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/wake.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/wake.F90	(revision 4446)
@@ -2186,2 +2308,360 @@
   RETURN
 END SUBROUTINE wake_vec_modulation
+
+
+
+SUBROUTINE pkupper (klon, klev, ptop, ph, pupper, kupper)
+
+USE wake_ini_mod , ONLY : pupperbyphs
+IMPLICIT NONE
+
+INTEGER,  INTENT(IN)                              :: klon,klev
+REAL,     INTENT(IN),   DIMENSION (klon,klev+1)   :: ph
+REAL,     INTENT(IN),   DIMENSION (klon)          :: ptop
+REAL,     INTENT(OUT),  DIMENSION (klon)          :: pupper
+INTEGER,  INTENT(OUT),  DIMENSION (klon)          :: kupper
+INTEGER                                           :: i,k
+
+
+ kupper = 0
+ 
+IF (pupperbyphs<1.) THEN
+ ! Choose an integration bound well above wake top
+  ! -----------------------------------------------------------------
+
+  ! Pupper = 50000.  ! melting level
+  ! Pupper = 60000.
+  ! Pupper = 80000.  ! essais pour case_e
+  DO i = 1, klon
+  !  pupper(i) = 0.6*ph(i, 1)
+    pupper(i) = pupperbyphs*ph(i, 1)
+    pupper(i) = max(pupper(i), 45000.)
+    ! cc        Pupper(i) = 60000.
+  END DO
+
+ELSE
+  
+  DO i=1, klon
+     ! pupper(i) = pupperbyphs*ptop(i)+(1.-pupperbyphs)*ph(i, 1) 
+     pupper(i) = min( pupperbyphs*ptop(i)+(1.-pupperbyphs)*ph(i, 1) , ptop(i)-5000.) 
+  END DO
+END IF
+ 
+  ! -5/ Determination de kupper
+
+  DO k = klev, 1, -1
+    DO i = 1, klon
+      IF (ph(i,k+1)<pupper(i)) kupper(i) = k
+    END DO
+  END DO
+
+  ! On evite kupper = 1 et kupper = klev
+  DO i = 1, klon
+    kupper(i) = max(kupper(i), 2)
+    kupper(i) = min(kupper(i), klev-1)
+  END DO 
+    RETURN
+END SUBROUTINE pkupper
+
+
+SUBROUTINE wake_popdyn_1(klon, klev, dtime, cstar, tau_wk_inv, wgen, wdens, awdens, sigmaw, &
+                  dtimesub, gfl, rad_wk, f_shear, drdt_pos, &
+                  d_awdens, d_wdens, d_sigmaw, &
+                  iflag_wk_act, wk_adv, cin, wape, &
+                  drdt, &
+                  d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
+                  d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
+                  d_wdens_targ, d_sigmaw_targ)
+                
+
+  USE wake_ini_mod , ONLY : wake_ini
+  USE wake_ini_mod , ONLY : prt_level,RG
+  USE wake_ini_mod , ONLY : stark, wdens_ref
+  USE wake_ini_mod , ONLY : tau_cv, rzero, aa0
+  USE wake_ini_mod , ONLY : iflag_wk_pop_dyn, wdensmin
+  USE wake_ini_mod , ONLY : sigmad, cstart, sigmaw_max
+  
+IMPLICIT NONE
+
+  INTEGER, INTENT(IN)                                   :: klon,klev
+  LOGICAL, DIMENSION (klon),        INTENT(IN)          :: wk_adv
+  REAL,                             INTENT(IN)          :: dtime
+  REAL,                             INTENT(IN)          :: dtimesub
+  REAL, DIMENSION (klon),           INTENT(IN)          :: wgen
+  REAL, DIMENSION (klon),           INTENT(IN)          :: wdens
+  REAL, DIMENSION (klon),           INTENT(IN)          :: awdens
+  REAL, DIMENSION (klon),           INTENT(IN)          :: sigmaw
+  REAL, DIMENSION (klon),           INTENT(IN)          :: gfl, cstar
+  REAL, DIMENSION (klon),           INTENT(IN)          :: cin, wape
+  REAL, DIMENSION (klon),           INTENT(IN)          :: rad_wk
+  REAL, DIMENSION (klon),           INTENT(IN)          :: f_shear
+  INTEGER,                          INTENT(IN)          :: iflag_wk_act
+
+  
+  !
+ 
+  ! Tendencies of state variables (2 is appended to the names of fields which are the cumul of fields 
+  !                                 computed at each sub-timestep; e.g. d_wdens2 is the cumul of d_wdens)
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sigmaw, d_awdens, d_wdens
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: drdt
+  ! Some components of the tendencies of state variables  
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sig_gen, d_sig_death, d_sig_col, d_sig_bnd
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sig_spread
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
+  REAL,                             INTENT(OUT)         :: d_wdens_targ, d_sigmaw_targ
+ 
+  
+  REAL                                                  :: delta_t_min
+  INTEGER                                               :: nsub
+  INTEGER                                               :: i, k
+  REAL                                                  :: wdens0
+  ! IM 080208
+  LOGICAL, DIMENSION (klon)                             :: gwake
+  
+   ! Variables liees a la dynamique de population
+  REAL, DIMENSION(klon)                                 :: act
+  REAL, DIMENSION(klon)                                 :: tau_wk_inv
+  REAL, DIMENSION(klon)                                 :: wape1_act, wape2_act
+  LOGICAL, DIMENSION (klon)                             :: kill_wake
+  REAL                                                  :: drdt_pos
+  REAL                                                  :: tau_wk_inv_min
+  
+     
+
+      IF (iflag_wk_act == 0) THEN
+        act(:) = 0.
+      ELSEIF (iflag_wk_act == 1) THEN
+        act(:) = 1.
+      ELSEIF (iflag_wk_act ==2) THEN
+      DO i = 1, klon
+        IF (wk_adv(i)) THEN
+          wape1_act(i) = abs(cin(i))
+          wape2_act(i) = 2.*wape1_act(i) + 1.
+          act(i) = min(1., max(0., (wape(i)-wape1_act(i)) / (wape2_act(i)-wape1_act(i)) ))
+        ENDIF  ! (wk_adv(i))
+      ENDDO
+      ENDIF  ! (iflag_wk_act ==2)
+
+
+      DO i = 1, klon
+       ! print*, 'XXX wk_adv(i)', wk_adv(i)
+        IF (wk_adv(i)) THEN
+!!          tau_wk(i) = max(rad_wk(i)/(3.*cstar(i))*((cstar(i)/cstart)**1.5 - 1), 100.)
+          tau_wk_inv(i) = max( (3.*cstar(i))/(rad_wk(i)*((cstar(i)/cstart)**1.5 - 1)), 0.)
+          tau_wk_inv_min = min(tau_wk_inv(i), 1./dtimesub)
+          drdt(i) = (cstar(i) - wgen(i)*(sigmaw(i)/wdens(i)-aa0)/gfl(i)) / &
+                    (1 + 2*f_shear(i)*(2.*sigmaw(i)-aa0*wdens(i)) - 2.*sigmaw(i))
+!!                    (1 - 2*sigmaw(i)*(1.-f_shear(i)))
+          drdt_pos=max(drdt(i),0.)
+
+!!          d_wdens(i) = ( wgen(i)*(1.+2.*(sigmaw(i)-sigmad)) &
+!!                     - wdens(i)*tau_wk_inv_min &
+!!                     - 2.*gfl(i)*wdens(i)*Cstar(i) )*dtimesub
+!jyg+mlt<
+          d_awdens(i) = ( wgen(i) - (1./tau_cv)*(awdens(i) - act(i)*wdens(i)) )*dtimesub
+          d_dens_gen(i) = wgen(i)
+          d_dens_death(i) = - (wdens(i)-awdens(i))*tau_wk_inv_min 
+          d_dens_col(i) =  -2.*wdens(i)*gfl(i)*drdt_pos 
+          d_dens_gen(i) =  d_dens_gen(i)*dtimesub
+          d_dens_death(i) = d_dens_death(i)*dtimesub
+          d_dens_col(i) =  d_dens_col(i)*dtimesub 
+
+          d_wdens(i) = d_dens_gen(i)+d_dens_death(i)+d_dens_col(i)
+!!          d_wdens(i) = ( wgen(i) - (wdens(i)-awdens(i))*tau_wk_inv_min -  &
+!!                         2.*wdens(i)*gfl(i)*drdt_pos )*dtimesub
+!>jyg+mlt
+!
+!jyg<
+          d_wdens_targ = max(d_wdens(i), wdensmin-wdens(i))
+!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+          d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
+          d_wdens(i) = d_wdens_targ
+!!          d_wdens(i) = max(d_wdens(i), wdensmin-wdens(i))
+!>jyg
+
+!jyg+mlt<
+!!          d_sigmaw(i) = ( (1.-2*f_shear(i)*sigmaw(i))*(gfl(i)*Cstar(i)+wgen(i)*sigmad/wdens(i)) &
+!!                      + 2.*f_shear(i)*wgen(i)*sigmaw(i)**2/wdens(i) &
+!!                      - sigmaw(i)*tau_wk_inv_min )*dtimesub
+          d_sig_gen(i) = wgen(i)*aa0
+!!          print*, 'XXX sigmaw(i), awdens(i), wdens(i), tau_wk_inv_min', &
+!!                  sigmaw(i), awdens(i), wdens(i), tau_wk_inv_min
+          d_sig_death(i) = - sigmaw(i)*(1.-awdens(i)/wdens(i))*tau_wk_inv_min
+!!        
+          
+          d_sig_col(i) = - 2*f_shear(i)*sigmaw(i)*gfl(i)*drdt_pos
+          d_sig_col(i) = - 2*f_shear(i)*(2.*sigmaw(i)-wdens(i)*aa0)*gfl(i)*drdt_pos
+          d_sig_spread(i) = gfl(i)*cstar(i)
+          d_sig_gen(i) =  d_sig_gen(i)*dtimesub
+          d_sig_death(i) = d_sig_death(i)*dtimesub
+          d_sig_col(i) =  d_sig_col(i)*dtimesub 
+          d_sig_spread(i) =  d_sig_spread(i)*dtimesub 
+          d_sigmaw(i) =  d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
+!>jyg+mlt
+!
+!jyg<
+          d_sigmaw_targ = max(d_sigmaw(i), sigmad-sigmaw(i))
+!!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
+!!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
+          d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
+          d_sigmaw(i) = d_sigmaw_targ
+!!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
+!>jyg
+        ENDIF
+      ENDDO
+
+      IF (prt_level >= 10) THEN
+        print *,'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), drdt(1) ', &
+                       cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), drdt(1)
+        print *,'wake, wdens(1), awdens(1), act(1), d_awdens(1) ', &
+                       wdens(1), awdens(1), act(1), d_awdens(1)
+        print *,'wake, wgen, -(wdens-awdens)*tau_wk_inv, -2.*wdens*gfl*drdt_pos, d_wdens ', &
+                       wgen(1), -(wdens(1)-awdens(1))*tau_wk_inv(1), -2.*wdens(1)*gfl(1)*drdt_pos, d_wdens(1)
+        print *,'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
+                       d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
+      ENDIF
+    
+    RETURN 
+    END SUBROUTINE wake_popdyn_1
+    
+    SUBROUTINE wake_popdyn_2 ( klon, klev, wk_adv, dtimesub, wgen, &
+                             sigmaw, wdens, awdens, &   !! states variables
+                             gfl, cstar, cin, wape, rad_wk, &
+                             d_sigmaw, d_wdens, d_awdens, &  !! tendences 
+                             cont_fact, &
+                             d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
+                             d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
+                             d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd )
+                             
+                                             
+
+  USE wake_ini_mod , ONLY : wake_ini
+  USE wake_ini_mod , ONLY : prt_level,RG
+  USE wake_ini_mod , ONLY : stark, wdens_ref
+  USE wake_ini_mod , ONLY : tau_cv, rzero, aa0
+  USE wake_ini_mod , ONLY : iflag_wk_pop_dyn, wdensmin
+  USE wake_ini_mod , ONLY : sigmad, cstart, sigmaw_max
+  
+IMPLICIT NONE
+
+  INTEGER, INTENT(IN)                                   :: klon,klev
+  LOGICAL, DIMENSION (klon),        INTENT(IN)          :: wk_adv
+  REAL,                             INTENT(IN)          :: dtimesub
+  REAL, DIMENSION (klon),           INTENT(IN)          :: wgen      !! B = birth rate of wakes
+  REAL, DIMENSION (klon),           INTENT(INOUT)       :: sigmaw    !! sigma = fractional area of wakes 
+  REAL, DIMENSION (klon),           INTENT(INOUT)       :: wdens     !! D = number of wakes per unit area 
+  REAL, DIMENSION (klon),           INTENT(INOUT)       :: awdens    !! A = number of active wakes per unit area
+  REAL, DIMENSION (klon),           INTENT(IN)          :: gfl       !! Lg = gust front lenght per unit area
+  REAL, DIMENSION (klon),           INTENT(IN)          :: cstar     !! C* = spreading velocity of wakes
+  REAL, DIMENSION (klon),           INTENT(IN)          :: cin, wape  ! RM : A Faire disparaitre
+  REAL, DIMENSION (klon),           INTENT(IN)          :: rad_wk    !! r = wake radius
+
+!  
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sigmaw, d_wdens, d_awdens
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: cont_fact  !! RM facteur de contact = 2 pi * rad * C*
+  ! Some components of the tendencies of state variables  
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd
+
+
+!! internal variables
+  
+  INTEGER                                               :: i, k
+  REAL, DIMENSION (klon)                                :: tau_wk_inv      !! tau = life time of wakes
+  REAL                                                  :: tau_wk_inv_min
+  REAL, DIMENSION (klon)                                :: tau_prime       !! tau_prime = life time of actives wakes
+  REAL                                                  :: d_wdens_targ, d_sigmaw_targ
+  
+
+!! Equations
+!! dD/dt = B - (D-A)/tau - f D^2
+!! dA/dt = B - A/tau_prime + f (D-A)^2 - f A^2
+!! dsigma/dt = B a0 - sigma/D (D-A)/tau + Lg C* - f (D-A)^2 (sigma/D-a0)
+!!
+!! f = 2 (B (a0-sigma/D) + Lg C*) / (2 (D-A)^2 (2 sigma/D-a0) + D (1-2 sigma))
+
+
+      DO i = 1, klon
+       ! print*, 'XXX wk_adv(i)', wk_adv(i)
+        IF (wk_adv(i)) THEN
+!!          tau_wk(i) = max(rad_wk(i)/(3.*cstar(i))*((cstar(i)/cstart)**1.5 - 1), 100.)
+          tau_wk_inv(i) = max( (3.*cstar(i))/(rad_wk(i)*((cstar(i)/cstart)**1.5 - 1)), 0.)
+          tau_wk_inv_min = min(tau_wk_inv(i), 1./dtimesub)
+          tau_prime(i) = tau_cv
+!!          cont_fact(i) = 2.*(wgen(i)*(aa0-sigmaw(i)/wdens(i)) + gfl(i)*cstar(i)) / &
+!!                             (2.*(wdens(i)-awdens(i))**2*(2.*sigmaw(i)/wdens(i) - aa0) + wdens(i)*(1.-2.*sigmaw(i)))
+!!          cont_fact(i) = 2.*3.14*rad_wk(i)*cstar(i)     ! bug
+!!          cont_fact(i) = 4.*3.14*rad_wk(i)*cstar(i)
+          cont_fact(i) = 2.*gfl(i)*cstar(i)/wdens(i)
+
+          d_sig_gen(i) = wgen(i)*aa0
+          d_sig_death(i) = - sigmaw(i)*(1.-awdens(i)/wdens(i))*tau_wk_inv_min
+          d_sig_col(i) = - cont_fact(i)*(wdens(i)-awdens(i))**2*(2.*sigmaw(i)/wdens(i)-aa0)
+          d_sig_spread(i) = gfl(i)*cstar(i)
+!
+          d_sig_gen(i) =  d_sig_gen(i)*dtimesub
+          d_sig_death(i) = d_sig_death(i)*dtimesub
+          d_sig_col(i) =  d_sig_col(i)*dtimesub 
+          d_sig_spread(i) =  d_sig_spread(i)*dtimesub 
+          d_sigmaw(i) =  d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + d_sig_spread(i)
+
+         
+          d_sigmaw_targ = max(d_sigmaw(i), sigmad-sigmaw(i))
+!!          d_sig_bnd(i) = d_sig_bnd(i) + d_sigmaw_targ - d_sigmaw(i)
+!!          d_sig_bnd_provis(i) = d_sigmaw_targ - d_sigmaw(i)
+          d_sig_bnd(i) = d_sigmaw_targ - d_sigmaw(i)
+          d_sigmaw(i) = d_sigmaw_targ
+!!          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
+         
+         
+          d_dens_gen(i) = wgen(i)
+          d_dens_death(i) = - (wdens(i)-awdens(i))*tau_wk_inv_min 
+          d_dens_col(i) =  - cont_fact(i)*wdens(i)**2
+! 
+          d_dens_gen(i) =  d_dens_gen(i)*dtimesub
+          d_dens_death(i) = d_dens_death(i)*dtimesub
+          d_dens_col(i) =  d_dens_col(i)*dtimesub 
+          d_wdens(i) = d_dens_gen(i) + d_dens_death(i) + d_dens_col(i)
+
+
+          d_adens_death(i) = -awdens(i)/tau_prime(i)
+          d_adens_icol(i) = cont_fact(i)*(wdens(i)-awdens(i))**2
+          d_adens_acol(i) = - cont_fact(i)*awdens(i)**2
+!
+          d_adens_death(i) =  d_adens_death(i)*dtimesub
+          d_adens_icol(i) =   d_adens_icol(i)*dtimesub
+          d_adens_acol(i) =   d_adens_acol(i)*dtimesub
+          d_awdens(i) =   d_dens_gen(i) + d_adens_death(i) + d_adens_icol(i) + d_adens_acol(i)     
+            
+!!
+          d_wdens_targ = max(d_wdens(i), wdensmin-wdens(i))
+!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+          d_dens_bnd(i) = d_wdens_targ - d_wdens(i)
+          d_wdens(i) = d_wdens_targ
+          
+          d_wdens_targ = min(max(d_awdens(i),-awdens(i)), wdens(i)-awdens(i))
+!!          d_dens_bnd(i) = d_dens_bnd(i) + d_wdens_targ - d_wdens(i)
+          d_adens_bnd(i) = d_wdens_targ - d_awdens(i)
+          d_awdens(i) = d_wdens_targ
+
+
+
+        ENDIF
+      ENDDO
+
+      IF (prt_level >= 10) THEN
+        print *,'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), cont_fact(1) ', &
+                       cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), cont_fact(1)
+        print *,'wake, wdens(1), awdens(1), d_awdens(1) ', &
+                       wdens(1), awdens(1), d_awdens(1)
+        print *,'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
+                       d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
+      ENDIF
+sigmaw=sigmaw+d_sigmaw
+wdens=wdens+d_wdens
+awdens=awdens+d_awdens
+
+    RETURN 
+    END SUBROUTINE wake_popdyn_2  
+  
Index: LMDZ6/branches/Portage_acc/libf/phylmd/wake_ini_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/wake_ini_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/wake_ini_mod.F90	(revision 4446)
@@ -17,16 +17,16 @@
 
   ! -------------------------------------------------------------------------
-  ! Déclaration de variables
-  ! -------------------------------------------------------------------------
-
-  ! Variables à fixer
+  ! Declaration de variables
+  ! -------------------------------------------------------------------------
+
+  ! Variables a fixer
 !jyg<
 !!  REAL, SAVE                                            :: stark, wdens_ref, coefgw, alpk
   INTEGER, SAVE, PROTECTED                                         :: prt_level
   REAL, SAVE, PROTECTED, DIMENSION(2)                              :: wdens_ref
-  REAL, SAVE, PROTECTED                                            :: stark, coefgw, alpk
+  REAL, SAVE, PROTECTED                                            :: stark, coefgw, alpk, pupperbyphs
 !>jyg
   REAL, SAVE, PROTECTED                                            :: crep_upper, crep_sol  
-  !$OMP THREADPRIVATE(stark, wdens_ref, coefgw, alpk, crep_upper, crep_sol)
+  !$OMP THREADPRIVATE(stark, wdens_ref, coefgw, alpk, pupperbyphs, crep_upper, crep_sol)
 
   REAL, SAVE, PROTECTED                                            :: tau_cv
@@ -44,4 +44,7 @@
   INTEGER, SAVE, PROTECTED                                         :: iflag_wk_pop_dyn
   !$OMP THREADPRIVATE(iflag_wk_pop_dyn)
+
+  INTEGER, SAVE, PROTECTED                                         :: iflag_wk_profile
+  !$OMP THREADPRIVATE(iflag_wk_profile)
 
   REAL, SAVE, PROTECTED                                            :: wdensmin
@@ -111,7 +114,7 @@
   ! Configuration de coefgw,stark,wdens (22/02/06 by YU Jingmei)
 
-  ! coefgw : Coefficient pour les ondes de gravité
+  ! coefgw : Coefficient pour les ondes de gravite
   ! stark : Coefficient k dans Cstar=k*sqrt(2*WAPE)
-  ! wdens : Densité surfacique de poche froide
+  ! wdens : Densite surfacique de poche froide
   ! -------------------------------------------------------------------------
 
@@ -149,4 +152,9 @@
   alpk=0.25
   CALL getin_p('alpk',alpk)
+  
+  pupperbyphs=0.6
+  CALL getin_p('pupperbyphs',pupperbyphs)
+
+
 !jyg<
 !!  wdens_ref=8.E-12
@@ -170,4 +178,7 @@
                                             ! 2: act(:)=f(Wape)
 
+  iflag_wk_profile = 0
+  CALL getin_p('iflag_wk_profile',iflag_wk_profile) ! switch between wdens prescribed 
+                                                    ! and wdens prognostic
   rzero = 5000.
   CALL getin_p('rzero_wk', rzero)
@@ -184,4 +195,5 @@
   WRITE(*,*) 'stark=', stark
   WRITE(*,*) 'alpk=', alpk
+  WRITE(*,*) 'pupperbyphs=', pupperbyphs
 !jyg<
 !!  WRITE(*,*) 'wdens_ref=', wdens_ref
Index: LMDZ6/branches/Portage_acc/libf/phylmd/write_bilKP_ave.h
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/write_bilKP_ave.h	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/write_bilKP_ave.h	(revision 4446)
@@ -49,5 +49,5 @@
       CALL histwrite_phy(nid_bilKPave,"play",itau_w,paprs)
 c
-cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, cldliq, zx_tmp_3d)
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, radocond, zx_tmp_3d)
       CALL histwrite_phy(nid_bilKPave,"oliq",itau_w,cldliq)
 c
Index: LMDZ6/branches/Portage_acc/libf/phylmd/write_bilKP_ins.h
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/write_bilKP_ins.h	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/write_bilKP_ins.h	(revision 4446)
@@ -49,5 +49,5 @@
       CALL histwrite_phy(nid_bilKPins,"play",itau_w,paprs)
 c
-cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, cldliq, zx_tmp_3d)
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, radocond, zx_tmp_3d)
       CALL histwrite_phy(nid_bilKPins,"oliq",itau_w,cldliq)
 c
Index: LMDZ6/branches/Portage_acc/libf/phylmd/yamada4.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/yamada4.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/yamada4.F90	(revision 4446)
@@ -444,5 +444,5 @@
          tkeprov= tkeprov*                           &
            &  (tkeprov+dt*(shear(ig,k)+max(0.,buoy(ig,k))))/ &
-           &  (tkeprov+dt*((-1.)*min(0.,buoy(ig,k))+dissip(ig,k)))
+           &  (tkeprov+dt*((-1.)*min(0.,buoy(ig,k))+dissip(ig,k)+drgpro(ig,k)*tkeprov))
          q2(ig,k)=tkeprov*ydeux
         ENDDO
@@ -497,10 +497,4 @@
          DO ig=1,ngrid
          tkeprov=q2(ig,k)/ydeux
-
-!             if(ifl_pbltree .eq. 0) then
-!         disseff=dissip(ig,k)-min(0.,buoy(ig,k))
-!         tkeexp=exp(-dt*disseff/tkeprov)
-!         tkeprov= shear(ig,k)*tkeprov/disseff*(1.-tkeexp)+tkeprov*tkeexp
-!           else
 !FC on ajoute la dissipation due aux arbres
          disseff=dissip(ig,k)-min(0.,buoy(ig,k)) + drgpro(ig,k)*tkeprov
@@ -510,8 +504,5 @@
          tkeprov= (shear(ig,k)+ &
           & drgpro(ig,k)*(winds(ig,k))**3)*tkeprov/disseff*(1.-tkeexp)+tkeprov*tkeexp
-!               endif
-
          q2(ig,k)=tkeprov*ydeux
-
          ! En cas stable, on traite la flotabilite comme la
          ! dissipation, en supposant que buoy/q2^3 est constant.
@@ -522,14 +513,7 @@
        DO k = 2, klev - 1
          DO ig=1,ngrid
-         !tkeprov=q2(ig,k)/ydeux
-         !tkeprov=tkeprov+max(buoy(ig,k)+shear(ig,k),0.)*dt
-         !disseff=dissip(ig,k)-min(0.,buoy(ig,k)+shear(ig,k)) 
-         !tkeexp=exp(-dt*disseff/tkeprov)
-         !tkeprov= tkeprov*tkeexp
-         !q2(ig,k)=tkeprov*ydeux
          ! En cas stable, on traite la flotabilite comme la
          ! dissipation, en supposant que dissipeff/TKE est constant.
          ! Puis on prend la solution exacte
-         ! 
          ! With drag and dissipation from high vegetation (EV & FC, 05/10/2020)
          winds(ig,k)=sqrt(u(ig,k)**2+v(ig,k)**2)
Index: LMDZ6/branches/Portage_acc/libf/phylmdiso/add_phys_tend_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmdiso/add_phys_tend_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmdiso/add_phys_tend_mod.F90	(revision 4446)
@@ -39,5 +39,5 @@
   USE mod_grid_phy_lmdz, ONLY: nbp_lev
 #ifdef ISO
-  USE infotrac_phy, ONLY: ntraciso
+  USE infotrac_phy, ONLY: ntraciso=>ntiso
   USE isotopes_mod, ONLY: iso_eau
 #endif
@@ -154,5 +154,5 @@
 
 #ifdef ISO
-    USE infotrac_phy, ONLY: ntraciso  
+    USE infotrac_phy, ONLY: ntraciso=>ntiso
 #ifdef ISOVERIF
     USE isotopes_mod, ONLY: iso_eau
Index: LMDZ6/branches/Portage_acc/libf/phylmdiso/add_wake_tend.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmdiso/add_wake_tend.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmdiso/add_wake_tend.F90	(revision 4446)
@@ -18,5 +18,5 @@
 USE print_control_mod, ONLY: prt_level
 #ifdef ISO
-    USE infotrac_phy, ONLY: ntraciso    
+    USE infotrac_phy, ONLY: ntiso    
     USE phys_state_var_mod, ONLY:  wake_deltaxt   
 #endif
@@ -31,5 +31,5 @@
   INTEGER,                       INTENT (IN)         :: abortphy
 #ifdef ISO
-  REAL, DIMENSION(ntraciso,klon, klev),   INTENT (IN)         :: zddeltaxt
+  REAL, DIMENSION(ntiso, klon, klev), INTENT (IN)    :: zddeltaxt
 #endif
 
@@ -61,5 +61,5 @@
                wake_deltaq(i, l) = wake_deltaq(i, l) + zddeltaq(i,l)
 #ifdef ISO
-               do ixt=1,ntraciso
+               do ixt=1,ntiso
                  wake_deltaxt(ixt,i, l) = wake_deltaxt(ixt,i, l) + zddeltaxt(ixt,i,l)
                enddo
@@ -69,5 +69,5 @@
                wake_deltaq(i, l) = 0.
 #ifdef ISO
-               do ixt=1,ntraciso
+               do ixt=1,ntiso
                  wake_deltaxt(ixt,i, l) = 0.0
                enddo
Index: LMDZ6/branches/Portage_acc/libf/phylmdiso/ajsec.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmdiso/ajsec.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmdiso/ajsec.F90	(revision 4446)
@@ -9,5 +9,5 @@
   USE dimphy
 #ifdef ISO
-    USE infotrac_phy, ONLY: ntraciso    
+    USE infotrac_phy, ONLY: ntraciso =>ntiso   
 #ifdef ISOVERIF
   USE isotopes_mod, ONLY : iso_eau,iso_HDO
@@ -303,5 +303,5 @@
   USE dimphy
 #ifdef ISO
-    USE infotrac_phy, ONLY: ntraciso       
+    USE infotrac_phy, ONLY: ntraciso=>ntiso    
 #ifdef ISOVERIF
   USE isotopes_mod, ONLY : iso_eau,iso_HDO
Index: LMDZ6/branches/Portage_acc/libf/phylmdiso/calwake.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmdiso/calwake.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmdiso/calwake.F90	(revision 4446)
@@ -35,5 +35,5 @@
   USE print_control_mod, ONLY: mydebug=>debug , lunout, prt_level
 #ifdef ISO
-  USE infotrac_phy, ONLY : ntraciso
+  USE infotrac_phy, ONLY : ntraciso=>ntiso
 #ifdef ISOVERIF
   USE isotopes_mod, ONLY: iso_eau
Index: LMDZ6/branches/Portage_acc/libf/phylmdiso/change_srf_frac_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmdiso/change_srf_frac_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmdiso/change_srf_frac_mod.F90	(revision 4446)
@@ -39,5 +39,5 @@
     USE print_control_mod, ONLY: lunout
 #ifdef ISO
-  USE infotrac_phy, ONLY: ntraciso    
+  USE infotrac_phy, ONLY: ntiso    
 #endif
     
@@ -66,5 +66,5 @@
 !albedo SB <<<
 #ifdef ISO
-    REAL, DIMENSION(ntraciso,klon,nbsrf), INTENT(INOUT)        :: xtevap
+    REAL, DIMENSION(ntiso,klon,nbsrf), INTENT(INOUT)        :: xtevap
 #endif
 
Index: LMDZ6/branches/Portage_acc/libf/phylmdiso/climb_hq_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmdiso/climb_hq_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmdiso/climb_hq_mod.F90	(revision 4446)
@@ -6,5 +6,5 @@
   USE dimphy
 #ifdef ISO
-  USE infotrac_phy, ONLY: ntraciso ! ajout C Risi pour isos      
+  USE infotrac_phy, ONLY: ntraciso=>ntiso ! ajout C Risi pour isos      
 #endif
 
@@ -59,5 +59,4 @@
             )
 #ifdef ISOVERIF
-!USE infotrac_phy, ONLY: use_iso
 USE isotopes_mod, ONLY: iso_eau,iso_HDO
 !USE isotopes_verif_mod, ONLY: errmax, errmaxrel
Index: LMDZ6/branches/Portage_acc/libf/phylmdiso/concvl.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmdiso/concvl.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmdiso/concvl.F90	(revision 4446)
@@ -44,5 +44,5 @@
   USE infotrac_phy, ONLY: nbtr
 #ifdef ISO
-  USE infotrac_phy, ONLY: ntraciso
+  USE infotrac_phy, ONLY: ntraciso=>ntiso
   USE isotopes_mod, ONLY: iso_eau, bidouille_anti_divergence, ridicule, &
         iso_eau,iso_HDO
